package twostackqueue;

import java.util.ArrayDeque;

/**
 * A StandardLibraryQueue is a FIFO dispenser implemented with a
 * java.util.ArrayDeque.
 */
public class StandardLibraryQueue<T>
        implements Dispenser<T> {

  private ArrayDeque<T> deque;

  /**
   * new StandarLibraryQueue<T>() returns a FIFO dispenser for objects of type
   * T.
   * The implementation uses a java.util.ArrayDeque.
   */
  public StandardLibraryQueue() {
    deque = new ArrayDeque<T>();
  }

  /**
   * q.add(t) adds t to q.
   * @param t the item to be added
   */
  public void add(T t) {
    deque.addLast(t);
  }

  /**
   * q.isEmpty() returns true if q is empty.
   * @return
   */
  public boolean isEmpty() {
    return deque.isEmpty();
  }

  /**
   * q.remove() removes and returns the oldest item in q.
   * @return the oldest item
   */
  public T remove() {
    return deque.removeFirst();
  }

}
